test_must_be_empty: simplify file existence check
[alt-git.git] / t / test-lib-functions.sh
blob36ad8accddb25656ffd86f3baf6ac1c5728ec332
1 # Library of functions shared by all tests scripts, included by
2 # test-lib.sh.
4 # Copyright (c) 2005 Junio C Hamano
6 # This program is free software: you can redistribute it and/or modify
7 # it under the terms of the GNU General Public License as published by
8 # the Free Software Foundation, either version 2 of the License, or
9 # (at your option) any later version.
11 # This program is distributed in the hope that it will be useful,
12 # but WITHOUT ANY WARRANTY; without even the implied warranty of
13 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
14 # GNU General Public License for more details.
16 # You should have received a copy of the GNU General Public License
17 # along with this program. If not, see http://www.gnu.org/licenses/ .
19 # The semantics of the editor variables are that of invoking
20 # sh -c "$EDITOR \"$@\"" files ...
22 # If our trash directory contains shell metacharacters, they will be
23 # interpreted if we just set $EDITOR directly, so do a little dance with
24 # environment variables to work around this.
26 # In particular, quoting isn't enough, as the path may contain the same quote
27 # that we're using.
28 test_set_editor () {
29 FAKE_EDITOR="$1"
30 export FAKE_EDITOR
31 EDITOR='"$FAKE_EDITOR"'
32 export EDITOR
35 test_set_index_version () {
36 GIT_INDEX_VERSION="$1"
37 export GIT_INDEX_VERSION
40 test_decode_color () {
41 awk '
42 function name(n) {
43 if (n == 0) return "RESET";
44 if (n == 1) return "BOLD";
45 if (n == 7) return "REVERSE";
46 if (n == 30) return "BLACK";
47 if (n == 31) return "RED";
48 if (n == 32) return "GREEN";
49 if (n == 33) return "YELLOW";
50 if (n == 34) return "BLUE";
51 if (n == 35) return "MAGENTA";
52 if (n == 36) return "CYAN";
53 if (n == 37) return "WHITE";
54 if (n == 40) return "BLACK";
55 if (n == 41) return "BRED";
56 if (n == 42) return "BGREEN";
57 if (n == 43) return "BYELLOW";
58 if (n == 44) return "BBLUE";
59 if (n == 45) return "BMAGENTA";
60 if (n == 46) return "BCYAN";
61 if (n == 47) return "BWHITE";
64 while (match($0, /\033\[[0-9;]*m/) != 0) {
65 printf "%s<", substr($0, 1, RSTART-1);
66 codes = substr($0, RSTART+2, RLENGTH-3);
67 if (length(codes) == 0)
68 printf "%s", name(0)
69 else {
70 n = split(codes, ary, ";");
71 sep = "";
72 for (i = 1; i <= n; i++) {
73 printf "%s%s", sep, name(ary[i]);
74 sep = ";"
77 printf ">";
78 $0 = substr($0, RSTART + RLENGTH, length($0) - RSTART - RLENGTH + 1);
80 print
85 lf_to_nul () {
86 perl -pe 'y/\012/\000/'
89 nul_to_q () {
90 perl -pe 'y/\000/Q/'
93 q_to_nul () {
94 perl -pe 'y/Q/\000/'
97 q_to_cr () {
98 tr Q '\015'
101 q_to_tab () {
102 tr Q '\011'
105 qz_to_tab_space () {
106 tr QZ '\011\040'
109 append_cr () {
110 sed -e 's/$/Q/' | tr Q '\015'
113 remove_cr () {
114 tr '\015' Q | sed -e 's/Q$//'
117 # In some bourne shell implementations, the "unset" builtin returns
118 # nonzero status when a variable to be unset was not set in the first
119 # place.
121 # Use sane_unset when that should not be considered an error.
123 sane_unset () {
124 unset "$@"
125 return 0
128 test_tick () {
129 if test -z "${test_tick+set}"
130 then
131 test_tick=1112911993
132 else
133 test_tick=$(($test_tick + 60))
135 GIT_COMMITTER_DATE="$test_tick -0700"
136 GIT_AUTHOR_DATE="$test_tick -0700"
137 export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
140 # Stop execution and start a shell. This is useful for debugging tests.
142 # Be sure to remove all invocations of this command before submitting.
144 test_pause () {
145 "$SHELL_PATH" <&6 >&5 2>&7
148 # Wrap git in gdb. Adding this to a command can make it easier to
149 # understand what is going on in a failing test.
151 # Example: "debug git checkout master".
152 debug () {
153 GIT_TEST_GDB=1 "$@" <&6 >&5 2>&7
156 # Call test_commit with the arguments
157 # [-C <directory>] <message> [<file> [<contents> [<tag>]]]"
159 # This will commit a file with the given contents and the given commit
160 # message, and tag the resulting commit with the given tag name.
162 # <file>, <contents>, and <tag> all default to <message>.
164 # If the first argument is "-C", the second argument is used as a path for
165 # the git invocations.
167 test_commit () {
168 notick= &&
169 signoff= &&
170 indir= &&
171 while test $# != 0
173 case "$1" in
174 --notick)
175 notick=yes
177 --signoff)
178 signoff="$1"
181 indir="$2"
182 shift
185 break
187 esac
188 shift
189 done &&
190 indir=${indir:+"$indir"/} &&
191 file=${2:-"$1.t"} &&
192 echo "${3-$1}" > "$indir$file" &&
193 git ${indir:+ -C "$indir"} add "$file" &&
194 if test -z "$notick"
195 then
196 test_tick
197 fi &&
198 git ${indir:+ -C "$indir"} commit $signoff -m "$1" &&
199 git ${indir:+ -C "$indir"} tag "${4:-$1}"
202 # Call test_merge with the arguments "<message> <commit>", where <commit>
203 # can be a tag pointing to the commit-to-merge.
205 test_merge () {
206 test_tick &&
207 git merge -m "$1" "$2" &&
208 git tag "$1"
211 # This function helps systems where core.filemode=false is set.
212 # Use it instead of plain 'chmod +x' to set or unset the executable bit
213 # of a file in the working directory and add it to the index.
215 test_chmod () {
216 chmod "$@" &&
217 git update-index --add "--chmod=$@"
220 # Get the modebits from a file.
221 test_modebits () {
222 ls -l "$1" | sed -e 's|^\(..........\).*|\1|'
225 # Unset a configuration variable, but don't fail if it doesn't exist.
226 test_unconfig () {
227 config_dir=
228 if test "$1" = -C
229 then
230 shift
231 config_dir=$1
232 shift
234 git ${config_dir:+-C "$config_dir"} config --unset-all "$@"
235 config_status=$?
236 case "$config_status" in
237 5) # ok, nothing to unset
238 config_status=0
240 esac
241 return $config_status
244 # Set git config, automatically unsetting it after the test is over.
245 test_config () {
246 config_dir=
247 if test "$1" = -C
248 then
249 shift
250 config_dir=$1
251 shift
253 test_when_finished "test_unconfig ${config_dir:+-C '$config_dir'} '$1'" &&
254 git ${config_dir:+-C "$config_dir"} config "$@"
257 test_config_global () {
258 test_when_finished "test_unconfig --global '$1'" &&
259 git config --global "$@"
262 write_script () {
264 echo "#!${2-"$SHELL_PATH"}" &&
266 } >"$1" &&
267 chmod +x "$1"
270 # Use test_set_prereq to tell that a particular prerequisite is available.
271 # The prerequisite can later be checked for in two ways:
273 # - Explicitly using test_have_prereq.
275 # - Implicitly by specifying the prerequisite tag in the calls to
276 # test_expect_{success,failure,code}.
278 # The single parameter is the prerequisite tag (a simple word, in all
279 # capital letters by convention).
281 test_set_prereq () {
282 satisfied_prereq="$satisfied_prereq$1 "
284 satisfied_prereq=" "
285 lazily_testable_prereq= lazily_tested_prereq=
287 # Usage: test_lazy_prereq PREREQ 'script'
288 test_lazy_prereq () {
289 lazily_testable_prereq="$lazily_testable_prereq$1 "
290 eval test_prereq_lazily_$1=\$2
293 test_run_lazy_prereq_ () {
294 script='
295 mkdir -p "$TRASH_DIRECTORY/prereq-test-dir" &&
297 cd "$TRASH_DIRECTORY/prereq-test-dir" &&'"$2"'
299 say >&3 "checking prerequisite: $1"
300 say >&3 "$script"
301 test_eval_ "$script"
302 eval_ret=$?
303 rm -rf "$TRASH_DIRECTORY/prereq-test-dir"
304 if test "$eval_ret" = 0; then
305 say >&3 "prerequisite $1 ok"
306 else
307 say >&3 "prerequisite $1 not satisfied"
309 return $eval_ret
312 test_have_prereq () {
313 # prerequisites can be concatenated with ','
314 save_IFS=$IFS
315 IFS=,
316 set -- $*
317 IFS=$save_IFS
319 total_prereq=0
320 ok_prereq=0
321 missing_prereq=
323 for prerequisite
325 case "$prerequisite" in
327 negative_prereq=t
328 prerequisite=${prerequisite#!}
331 negative_prereq=
332 esac
334 case " $lazily_tested_prereq " in
335 *" $prerequisite "*)
338 case " $lazily_testable_prereq " in
339 *" $prerequisite "*)
340 eval "script=\$test_prereq_lazily_$prerequisite" &&
341 if test_run_lazy_prereq_ "$prerequisite" "$script"
342 then
343 test_set_prereq $prerequisite
345 lazily_tested_prereq="$lazily_tested_prereq$prerequisite "
346 esac
348 esac
350 total_prereq=$(($total_prereq + 1))
351 case "$satisfied_prereq" in
352 *" $prerequisite "*)
353 satisfied_this_prereq=t
356 satisfied_this_prereq=
357 esac
359 case "$satisfied_this_prereq,$negative_prereq" in
360 t,|,t)
361 ok_prereq=$(($ok_prereq + 1))
364 # Keep a list of missing prerequisites; restore
365 # the negative marker if necessary.
366 prerequisite=${negative_prereq:+!}$prerequisite
367 if test -z "$missing_prereq"
368 then
369 missing_prereq=$prerequisite
370 else
371 missing_prereq="$prerequisite,$missing_prereq"
373 esac
374 done
376 test $total_prereq = $ok_prereq
379 test_declared_prereq () {
380 case ",$test_prereq," in
381 *,$1,*)
382 return 0
384 esac
385 return 1
388 test_verify_prereq () {
389 test -z "$test_prereq" ||
390 expr >/dev/null "$test_prereq" : '[A-Z0-9_,!]*$' ||
391 error "bug in the test script: '$test_prereq' does not look like a prereq"
394 test_expect_failure () {
395 test_start_
396 test "$#" = 3 && { test_prereq=$1; shift; } || test_prereq=
397 test "$#" = 2 ||
398 error "bug in the test script: not 2 or 3 parameters to test-expect-failure"
399 test_verify_prereq
400 export test_prereq
401 if ! test_skip "$@"
402 then
403 say >&3 "checking known breakage: $2"
404 if test_run_ "$2" expecting_failure
405 then
406 test_known_broken_ok_ "$1"
407 else
408 test_known_broken_failure_ "$1"
411 test_finish_
414 test_expect_success () {
415 test_start_
416 test "$#" = 3 && { test_prereq=$1; shift; } || test_prereq=
417 test "$#" = 2 ||
418 error "bug in the test script: not 2 or 3 parameters to test-expect-success"
419 test_verify_prereq
420 export test_prereq
421 if ! test_skip "$@"
422 then
423 say >&3 "expecting success: $2"
424 if test_run_ "$2"
425 then
426 test_ok_ "$1"
427 else
428 test_failure_ "$@"
431 test_finish_
434 # test_external runs external test scripts that provide continuous
435 # test output about their progress, and succeeds/fails on
436 # zero/non-zero exit code. It outputs the test output on stdout even
437 # in non-verbose mode, and announces the external script with "# run
438 # <n>: ..." before running it. When providing relative paths, keep in
439 # mind that all scripts run in "trash directory".
440 # Usage: test_external description command arguments...
441 # Example: test_external 'Perl API' perl ../path/to/test.pl
442 test_external () {
443 test "$#" = 4 && { test_prereq=$1; shift; } || test_prereq=
444 test "$#" = 3 ||
445 error >&5 "bug in the test script: not 3 or 4 parameters to test_external"
446 descr="$1"
447 shift
448 test_verify_prereq
449 export test_prereq
450 if ! test_skip "$descr" "$@"
451 then
452 # Announce the script to reduce confusion about the
453 # test output that follows.
454 say_color "" "# run $test_count: $descr ($*)"
455 # Export TEST_DIRECTORY, TRASH_DIRECTORY and GIT_TEST_LONG
456 # to be able to use them in script
457 export TEST_DIRECTORY TRASH_DIRECTORY GIT_TEST_LONG
458 # Run command; redirect its stderr to &4 as in
459 # test_run_, but keep its stdout on our stdout even in
460 # non-verbose mode.
461 "$@" 2>&4
462 if test "$?" = 0
463 then
464 if test $test_external_has_tap -eq 0; then
465 test_ok_ "$descr"
466 else
467 say_color "" "# test_external test $descr was ok"
468 test_success=$(($test_success + 1))
470 else
471 if test $test_external_has_tap -eq 0; then
472 test_failure_ "$descr" "$@"
473 else
474 say_color error "# test_external test $descr failed: $@"
475 test_failure=$(($test_failure + 1))
481 # Like test_external, but in addition tests that the command generated
482 # no output on stderr.
483 test_external_without_stderr () {
484 # The temporary file has no (and must have no) security
485 # implications.
486 tmp=${TMPDIR:-/tmp}
487 stderr="$tmp/git-external-stderr.$$.tmp"
488 test_external "$@" 4> "$stderr"
489 test -f "$stderr" || error "Internal error: $stderr disappeared."
490 descr="no stderr: $1"
491 shift
492 say >&3 "# expecting no stderr from previous command"
493 if test ! -s "$stderr"
494 then
495 rm "$stderr"
497 if test $test_external_has_tap -eq 0; then
498 test_ok_ "$descr"
499 else
500 say_color "" "# test_external_without_stderr test $descr was ok"
501 test_success=$(($test_success + 1))
503 else
504 if test "$verbose" = t
505 then
506 output=$(echo; echo "# Stderr is:"; cat "$stderr")
507 else
508 output=
510 # rm first in case test_failure exits.
511 rm "$stderr"
512 if test $test_external_has_tap -eq 0; then
513 test_failure_ "$descr" "$@" "$output"
514 else
515 say_color error "# test_external_without_stderr test $descr failed: $@: $output"
516 test_failure=$(($test_failure + 1))
521 # debugging-friendly alternatives to "test [-f|-d|-e]"
522 # The commands test the existence or non-existence of $1. $2 can be
523 # given to provide a more precise diagnosis.
524 test_path_is_file () {
525 if ! test -f "$1"
526 then
527 echo "File $1 doesn't exist. $2"
528 false
532 test_path_is_dir () {
533 if ! test -d "$1"
534 then
535 echo "Directory $1 doesn't exist. $2"
536 false
540 # Check if the directory exists and is empty as expected, barf otherwise.
541 test_dir_is_empty () {
542 test_path_is_dir "$1" &&
543 if test -n "$(ls -a1 "$1" | egrep -v '^\.\.?$')"
544 then
545 echo "Directory '$1' is not empty, it contains:"
546 ls -la "$1"
547 return 1
551 test_path_is_missing () {
552 if test -e "$1"
553 then
554 echo "Path exists:"
555 ls -ld "$1"
556 if test $# -ge 1
557 then
558 echo "$*"
560 false
564 # test_line_count checks that a file has the number of lines it
565 # ought to. For example:
567 # test_expect_success 'produce exactly one line of output' '
568 # do something >output &&
569 # test_line_count = 1 output
572 # is like "test $(wc -l <output) = 1" except that it passes the
573 # output through when the number of lines is wrong.
575 test_line_count () {
576 if test $# != 3
577 then
578 error "bug in the test script: not 3 parameters to test_line_count"
579 elif ! test $(wc -l <"$3") "$1" "$2"
580 then
581 echo "test_line_count: line count for $3 !$1 $2"
582 cat "$3"
583 return 1
587 # Returns success if a comma separated string of keywords ($1) contains a
588 # given keyword ($2).
589 # Examples:
590 # `list_contains "foo,bar" bar` returns 0
591 # `list_contains "foo" bar` returns 1
593 list_contains () {
594 case ",$1," in
595 *,$2,*)
596 return 0
598 esac
599 return 1
602 # This is not among top-level (test_expect_success | test_expect_failure)
603 # but is a prefix that can be used in the test script, like:
605 # test_expect_success 'complain and die' '
606 # do something &&
607 # do something else &&
608 # test_must_fail git checkout ../outerspace
611 # Writing this as "! git checkout ../outerspace" is wrong, because
612 # the failure could be due to a segv. We want a controlled failure.
614 test_must_fail () {
615 case "$1" in
616 ok=*)
617 _test_ok=${1#ok=}
618 shift
621 _test_ok=
623 esac
624 "$@"
625 exit_code=$?
626 if test $exit_code -eq 0 && ! list_contains "$_test_ok" success
627 then
628 echo >&2 "test_must_fail: command succeeded: $*"
629 return 1
630 elif test_match_signal 13 $exit_code && list_contains "$_test_ok" sigpipe
631 then
632 return 0
633 elif test $exit_code -gt 129 && test $exit_code -le 192
634 then
635 echo >&2 "test_must_fail: died by signal $(($exit_code - 128)): $*"
636 return 1
637 elif test $exit_code -eq 127
638 then
639 echo >&2 "test_must_fail: command not found: $*"
640 return 1
641 elif test $exit_code -eq 126
642 then
643 echo >&2 "test_must_fail: valgrind error: $*"
644 return 1
646 return 0
649 # Similar to test_must_fail, but tolerates success, too. This is
650 # meant to be used in contexts like:
652 # test_expect_success 'some command works without configuration' '
653 # test_might_fail git config --unset all.configuration &&
654 # do something
657 # Writing "git config --unset all.configuration || :" would be wrong,
658 # because we want to notice if it fails due to segv.
660 test_might_fail () {
661 test_must_fail ok=success "$@"
664 # Similar to test_must_fail and test_might_fail, but check that a
665 # given command exited with a given exit code. Meant to be used as:
667 # test_expect_success 'Merge with d/f conflicts' '
668 # test_expect_code 1 git merge "merge msg" B master
671 test_expect_code () {
672 want_code=$1
673 shift
674 "$@"
675 exit_code=$?
676 if test $exit_code = $want_code
677 then
678 return 0
681 echo >&2 "test_expect_code: command exited with $exit_code, we wanted $want_code $*"
682 return 1
685 # test_cmp is a helper function to compare actual and expected output.
686 # You can use it like:
688 # test_expect_success 'foo works' '
689 # echo expected >expected &&
690 # foo >actual &&
691 # test_cmp expected actual
694 # This could be written as either "cmp" or "diff -u", but:
695 # - cmp's output is not nearly as easy to read as diff -u
696 # - not all diff versions understand "-u"
698 test_cmp() {
699 $GIT_TEST_CMP "$@"
702 # test_cmp_bin - helper to compare binary files
704 test_cmp_bin() {
705 cmp "$@"
708 # Call any command "$@" but be more verbose about its
709 # failure. This is handy for commands like "test" which do
710 # not output anything when they fail.
711 verbose () {
712 "$@" && return 0
713 echo >&2 "command failed: $(git rev-parse --sq-quote "$@")"
714 return 1
717 # Check if the file expected to be empty is indeed empty, and barfs
718 # otherwise.
720 test_must_be_empty () {
721 test_path_is_file "$1" &&
722 if test -s "$1"
723 then
724 echo "'$1' is not empty, it contains:"
725 cat "$1"
726 return 1
730 # Tests that its two parameters refer to the same revision
731 test_cmp_rev () {
732 git rev-parse --verify "$1" >expect.rev &&
733 git rev-parse --verify "$2" >actual.rev &&
734 test_cmp expect.rev actual.rev
737 # Print a sequence of integers in increasing order, either with
738 # two arguments (start and end):
740 # test_seq 1 5 -- outputs 1 2 3 4 5 one line at a time
742 # or with one argument (end), in which case it starts counting
743 # from 1.
745 test_seq () {
746 case $# in
747 1) set 1 "$@" ;;
748 2) ;;
749 *) error "bug in the test script: not 1 or 2 parameters to test_seq" ;;
750 esac
751 test_seq_counter__=$1
752 while test "$test_seq_counter__" -le "$2"
754 echo "$test_seq_counter__"
755 test_seq_counter__=$(( $test_seq_counter__ + 1 ))
756 done
759 # This function can be used to schedule some commands to be run
760 # unconditionally at the end of the test to restore sanity:
762 # test_expect_success 'test core.capslock' '
763 # git config core.capslock true &&
764 # test_when_finished "git config --unset core.capslock" &&
765 # hello world
768 # That would be roughly equivalent to
770 # test_expect_success 'test core.capslock' '
771 # git config core.capslock true &&
772 # hello world
773 # git config --unset core.capslock
776 # except that the greeting and config --unset must both succeed for
777 # the test to pass.
779 # Note that under --immediate mode, no clean-up is done to help diagnose
780 # what went wrong.
782 test_when_finished () {
783 # We cannot detect when we are in a subshell in general, but by
784 # doing so on Bash is better than nothing (the test will
785 # silently pass on other shells).
786 test "${BASH_SUBSHELL-0}" = 0 ||
787 error "bug in test script: test_when_finished does nothing in a subshell"
788 test_cleanup="{ $*
789 } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
792 # Most tests can use the created repository, but some may need to create more.
793 # Usage: test_create_repo <directory>
794 test_create_repo () {
795 test "$#" = 1 ||
796 error "bug in the test script: not 1 parameter to test-create-repo"
797 repo="$1"
798 mkdir -p "$repo"
800 cd "$repo" || error "Cannot setup test environment"
801 "$GIT_EXEC_PATH/git-init" "--template=$GIT_BUILD_DIR/templates/blt/" >&3 2>&4 ||
802 error "cannot run git init -- have you built things yet?"
803 mv .git/hooks .git/hooks-disabled
804 ) || exit
807 # This function helps on symlink challenged file systems when it is not
808 # important that the file system entry is a symbolic link.
809 # Use test_ln_s_add instead of "ln -s x y && git add y" to add a
810 # symbolic link entry y to the index.
812 test_ln_s_add () {
813 if test_have_prereq SYMLINKS
814 then
815 ln -s "$1" "$2" &&
816 git update-index --add "$2"
817 else
818 printf '%s' "$1" >"$2" &&
819 ln_s_obj=$(git hash-object -w "$2") &&
820 git update-index --add --cacheinfo 120000 $ln_s_obj "$2" &&
821 # pick up stat info from the file
822 git update-index "$2"
826 # This function writes out its parameters, one per line
827 test_write_lines () {
828 printf "%s\n" "$@"
831 perl () {
832 command "$PERL_PATH" "$@"
835 # Is the value one of the various ways to spell a boolean true/false?
836 test_normalize_bool () {
837 git -c magic.variable="$1" config --bool magic.variable 2>/dev/null
840 # Given a variable $1, normalize the value of it to one of "true",
841 # "false", or "auto" and store the result to it.
843 # test_tristate GIT_TEST_HTTPD
845 # A variable set to an empty string is set to 'false'.
846 # A variable set to 'false' or 'auto' keeps its value.
847 # Anything else is set to 'true'.
848 # An unset variable defaults to 'auto'.
850 # The last rule is to allow people to set the variable to an empty
851 # string and export it to decline testing the particular feature
852 # for versions both before and after this change. We used to treat
853 # both unset and empty variable as a signal for "do not test" and
854 # took any non-empty string as "please test".
856 test_tristate () {
857 if eval "test x\"\${$1+isset}\" = xisset"
858 then
859 # explicitly set
860 eval "
861 case \"\$$1\" in
862 '') $1=false ;;
863 auto) ;;
864 *) $1=\$(test_normalize_bool \$$1 || echo true) ;;
865 esac
867 else
868 eval "$1=auto"
872 # Exit the test suite, either by skipping all remaining tests or by
873 # exiting with an error. If "$1" is "auto", we then we assume we were
874 # opportunistically trying to set up some tests and we skip. If it is
875 # "true", then we report a failure.
877 # The error/skip message should be given by $2.
879 test_skip_or_die () {
880 case "$1" in
881 auto)
882 skip_all=$2
883 test_done
885 true)
886 error "$2"
889 error "BUG: test tristate is '$1' (real error: $2)"
890 esac
893 # The following mingw_* functions obey POSIX shell syntax, but are actually
894 # bash scripts, and are meant to be used only with bash on Windows.
896 # A test_cmp function that treats LF and CRLF equal and avoids to fork
897 # diff when possible.
898 mingw_test_cmp () {
899 # Read text into shell variables and compare them. If the results
900 # are different, use regular diff to report the difference.
901 local test_cmp_a= test_cmp_b=
903 # When text came from stdin (one argument is '-') we must feed it
904 # to diff.
905 local stdin_for_diff=
907 # Since it is difficult to detect the difference between an
908 # empty input file and a failure to read the files, we go straight
909 # to diff if one of the inputs is empty.
910 if test -s "$1" && test -s "$2"
911 then
912 # regular case: both files non-empty
913 mingw_read_file_strip_cr_ test_cmp_a <"$1"
914 mingw_read_file_strip_cr_ test_cmp_b <"$2"
915 elif test -s "$1" && test "$2" = -
916 then
917 # read 2nd file from stdin
918 mingw_read_file_strip_cr_ test_cmp_a <"$1"
919 mingw_read_file_strip_cr_ test_cmp_b
920 stdin_for_diff='<<<"$test_cmp_b"'
921 elif test "$1" = - && test -s "$2"
922 then
923 # read 1st file from stdin
924 mingw_read_file_strip_cr_ test_cmp_a
925 mingw_read_file_strip_cr_ test_cmp_b <"$2"
926 stdin_for_diff='<<<"$test_cmp_a"'
928 test -n "$test_cmp_a" &&
929 test -n "$test_cmp_b" &&
930 test "$test_cmp_a" = "$test_cmp_b" ||
931 eval "diff -u \"\$@\" $stdin_for_diff"
934 # $1 is the name of the shell variable to fill in
935 mingw_read_file_strip_cr_ () {
936 # Read line-wise using LF as the line separator
937 # and use IFS to strip CR.
938 local line
939 while :
941 if IFS=$'\r' read -r -d $'\n' line
942 then
943 # good
944 line=$line$'\n'
945 else
946 # we get here at EOF, but also if the last line
947 # was not terminated by LF; in the latter case,
948 # some text was read
949 if test -z "$line"
950 then
951 # EOF, really
952 break
955 eval "$1=\$$1\$line"
956 done
959 # Like "env FOO=BAR some-program", but run inside a subshell, which means
960 # it also works for shell functions (though those functions cannot impact
961 # the environment outside of the test_env invocation).
962 test_env () {
964 while test $# -gt 0
966 case "$1" in
967 *=*)
968 eval "${1%%=*}=\${1#*=}"
969 eval "export ${1%%=*}"
970 shift
973 "$@"
974 exit
976 esac
977 done
981 # Returns true if the numeric exit code in "$2" represents the expected signal
982 # in "$1". Signals should be given numerically.
983 test_match_signal () {
984 if test "$2" = "$((128 + $1))"
985 then
986 # POSIX
987 return 0
988 elif test "$2" = "$((256 + $1))"
989 then
990 # ksh
991 return 0
993 return 1
996 # Read up to "$1" bytes (or to EOF) from stdin and write them to stdout.
997 test_copy_bytes () {
998 perl -e '
999 my $len = $ARGV[1];
1000 while ($len > 0) {
1001 my $s;
1002 my $nread = sysread(STDIN, $s, $len);
1003 die "cannot read: $!" unless defined($nread);
1004 last unless $nread;
1005 print $s;
1006 $len -= $nread;
1008 ' - "$1"
1011 # run "$@" inside a non-git directory
1012 nongit () {
1013 test -d non-repo ||
1014 mkdir non-repo ||
1015 return 1
1018 GIT_CEILING_DIRECTORIES=$(pwd) &&
1019 export GIT_CEILING_DIRECTORIES &&
1020 cd non-repo &&
1021 "$@"